﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.5
@EndOfDesignText@
'Code module

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.

End Sub

Public Sub setFlagsAndShowPage (pageToShow As Page, isNavigationBarVisible As Boolean, isStatusBarHidden As Boolean, isLightStatusBar As Boolean)
	
	Dim nativeobjectInstance                                        As NativeObject
	
	Main.NavControl.NavigationBarVisible = isNavigationBarVisible

	nativeobjectInstance = Main.NavControl
	nativeobjectInstance.SetField ("myPrefersStatusBarHidden", isStatusBarHidden)
	nativeobjectInstance.SetField ("myPrefersLightStatusBar",  isLightStatusBar)
	Main.NavControl.ShowPage2 (pageToShow, False)
	
End Sub

#If OBJC
@end
#import <objc/runtime.h>
@interface UINavigationController (SM)
@property (nonatomic, readwrite, strong) NSObject * myPrefersStatusBarHidden;
@property (nonatomic, readwrite, strong) NSObject * myPrefersLightStatusBar;
@end
@implementation UINavigationController (SM)
- (NSObject *) myPrefersStatusBarHidden { return objc_getAssociatedObject (self, @selector (myPrefersStatusBarHidden)); }
- (void) setMyPrefersStatusBarHidden: (NSObject *) value { objc_setAssociatedObject (self, @selector (myPrefersStatusBarHidden), value, OBJC_ASSOCIATION_RETAIN_NONATOMIC); }
- (NSObject *) myPrefersLightStatusBar  { return objc_getAssociatedObject (self, @selector (myPrefersLightStatusBar)); }
- (void) setMyPrefersLightStatusBar:  (NSObject *) value { objc_setAssociatedObject (self, @selector (myPrefersLightStatusBar),  value, OBJC_ASSOCIATION_RETAIN_NONATOMIC); }

- (BOOL) prefersStatusBarHidden { NSNumber * value = self.myPrefersStatusBarHidden; return value.boolValue; }

- (UIStatusBarStyle) preferredStatusBarStyle { NSNumber * value = self.myPrefersLightStatusBar; 
if (@available (iOS 13, *)) { return value.boolValue ? UIStatusBarStyleLightContent : UIStatusBarStyleDarkContent; }
					else    { return value.boolValue ? UIStatusBarStyleLightContent : UIStatusBarStyleDefault; }; }	

// Do not redirect to ViewControllers					
- (UIViewController*) childViewControllerForStatusBarHidden { return nil; }
- (UIViewController*) childViewControllerForStatusBarStyle  { return nil; }
#End If
